diff --git a/totara/appraisal/lib.php b/totara/appraisal/lib.php
index 266e779..22ea9b7 100644
--- a/totara/appraisal/lib.php
+++ b/totara/appraisal/lib.php
@@ -1200,17 +1644,18 @@ class appraisal {
     public static function get_manage_list() {
         global $DB;
 
-        $sql = 'SELECT a.id, a.name, a.timestarted, a.status, COUNT(aua.id) as lnum
-                FROM {appraisal} a
-                LEFT JOIN {appraisal_user_assignment} aua ON (aua.appraisalid = a.id)
-                GROUP BY a.id, a.name, a.timestarted, a.status
-                ORDER BY a.status, a.timestarted DESC, a.name, a.id';
-        $appraisals = $DB->get_records_sql($sql);
+        $appraisals = $DB->get_records('appraisal', null, 'status, timestarted DESC, name, id');
 
         foreach ($appraisals as $appraisal) {
             if ($appraisal->status == self::STATUS_DRAFT) {
                 $assign = new totara_assign_appraisal('appraisal', new appraisal($appraisal->id));
                 $appraisal->lnum = $assign->get_current_users_count();
+            } else if ($appraisal->status == self::STATUS_ACTIVE) {
+                $params = array('appraisalid' => $appraisal->id, 'status' => self::STATUS_ACTIVE);
+                $appraisal->lnum = $DB->count_records('appraisal_user_assignment', $params);
+            } else {
+                $params = array('appraisalid' => $appraisal->id);
+                $appraisal->lnum = $DB->count_records('appraisal_user_assignment', $params);
             }
         }
         return $appraisals;
@@ -1321,6 +1766,7 @@ class appraisal {
         $sql = 'SELECT app.*,
                        userstotal.userstotal,
                        userscomplete.userscomplete,
+                       userscancelled.userscancelled,
                        usersoverdue.usersoverdue
                   FROM {appraisal} app
                   LEFT JOIN (SELECT COUNT(aua.userid) AS userstotal, aua.appraisalid
@@ -1332,6 +1778,11 @@ class appraisal {
                               WHERE aua.timecompleted IS NOT NULL
                               GROUP BY aua.appraisalid) userscomplete
                     ON app.id = userscomplete.appraisalid
+                  LEFT JOIN (SELECT COUNT(aua.userid) AS userscancelled, aua.appraisalid
+                               FROM {appraisal_user_assignment} aua
+                               WHERE aua.status = ?
+                            GROUP BY aua.appraisalid) userscancelled
+                    ON app.id = userscancelled.appraisalid
                   LEFT JOIN (SELECT COUNT(aua.userid) AS usersoverdue, ast.appraisalid
                                FROM {appraisal_user_assignment} aua
                                JOIN {appraisal_stage} ast
@@ -1341,7 +1792,7 @@ class appraisal {
                               GROUP BY ast.appraisalid) usersoverdue
                     ON app.id = usersoverdue.appraisalid
                  WHERE app.status = ?';
-        $appraisals = $DB->get_records_sql($sql, array(time(), self::STATUS_ACTIVE));
+        $appraisals = $DB->get_records_sql($sql, array(self::STATUS_CLOSED, time(), self::STATUS_ACTIVE));
 
         return $appraisals;
     }
@@ -1908,7 +2359,7 @@ class appraisal_stage {
         global $DB;
 
         if (!$DB->record_exists('appraisal_stage_data',
-                array('appraisalroleassignmentid' => $roleassignment->id, 'appraisalstageid' => $this->id))) {
+            array('appraisalroleassignmentid' => $roleassignment->id, 'appraisalstageid' => $this->id))) {
             // Mark the role as complete.
             $stage_data = new stdClass();
             $stage_data->appraisalroleassignmentid = $roleassignment->id;
@@ -1917,7 +2368,7 @@ class appraisal_stage {
             $DB->insert_record('appraisal_stage_data', $stage_data);
 
             // Check if all involved roles are complete for this user and stage.
-            $rolescompletion = $this->get_completion($roleassignment->subjectid, appraisal::ACCESS_CANANSWER);
+            $rolescompletion = $this->get_mandatory_completion($roleassignment->subjectid);
             $complete = true;
             foreach ($rolescompletion as $rolecompletion) {
                 if (!isset($rolecompletion->timecompleted)) {
@@ -2007,21 +2458,57 @@ class appraisal_stage {
                  WHERE asp.appraisalstageid = ?
                  ORDER BY aqfr.appraisalrole";
         $params[] = $this->id;
-        return $DB->get_records_sql($sql, $params);
-    }
+        $rolesrecords = $DB->get_records_sql($sql, $params);
 
+        $out = array();
+        foreach ($rolesrecords as $rolerecord) {
+            $out[$rolerecord->appraisalrole] = 1;
+        }
+        return array_keys($out);
+    }
 
     /**
-     * Get completion data for all roles involved in this stage, for the given user.
+     * Much the same as get_roles_involved() but linking to the appropriate userid
      *
-     * @param int $subjectid
-     * @param int $rights Only if they have the specified rights.
+     * @param subjectid the userid in the userassignment
      * @return array
      */
-    public function get_completion($subjectid, $rights = 0) {
+    public function get_user_roles_involved($rights, $subjectid) {
         global $DB;
 
         $roles = $this->get_roles_involved($rights);
+        if (!empty($roles)) {
+            list($insql, $inparam) = $DB->get_in_or_equal($roles);
+            $missingsql = "SELECT ara.appraisalrole, ara.userid
+                             FROM {appraisal_role_assignment} ara
+                             JOIN {appraisal_user_assignment} aua
+                               ON ara.appraisaluserassignmentid = aua.id
+                            WHERE aua.userid = ?
+                              AND aua.appraisalid = ?
+                              AND appraisalrole {$insql}";
+            $missingparams = array_merge(array($subjectid, $this->appraisalid), $inparam);
+            return $DB->get_records_sql($missingsql, $missingparams);
+        }
+        return array();
+    }
+
+    public function get_mandatory_completion($subjectid) {
+        global $DB;
+
+        $cananswer = $this->get_user_roles_involved(appraisal::ACCESS_CANANSWER, $subjectid);
+        $mustanswer = $this->get_user_roles_involved(appraisal::ACCESS_MUSTANSWER, $subjectid);
+
+        $roles = array();
+
+        foreach ($mustanswer as $role) {
+            $roles[$role->appraisalrole] = $role->appraisalrole;
+        }
+
+        foreach ($cananswer as $role) {
+            if (!empty($role->userid)) {
+                $roles[$role->appraisalrole] = $role->appraisalrole;
+            }
+        }
 
         $sql = 'SELECT ara.appraisalrole, ara.userid, ara.activepageid, asd.timecompleted
                   FROM {appraisal_role_assignment} ara
@@ -2032,7 +2519,6 @@ class appraisal_stage {
                     ON ara.id = asd.appraisalroleassignmentid
                  WHERE aua.userid = ?
                    AND aua.appraisalid = ?
-                   AND ara.userid <> 0
                  ORDER BY ara.appraisalrole';
         $completiondata = $DB->get_records_sql($sql, array($this->id, $subjectid, $this->appraisalid));
         return array_intersect_key($completiondata, $roles);
@@ -3336,16 +3822,12 @@ class appraisal_question extends question_storage {
                 $isviewonlyquestion = false;
                 // Show role user icon.
                 $subjectid = $otherassignments[$eachrole]->userid;
-                if ($subjectid == 0) {
-                    continue;
-                }
-
-                $subject = $DB->get_record('user', array('id' => $subjectid));
 
                 // Add information about other roles to element.
-                $questioninfo = new question_manager($subject->id, $otherassignments[$eachrole]->id);
+                $questioninfo = new question_manager($subjectid, $otherassignments[$eachrole]->id);
                 $questioninfo->viewonly = true;
-                if (!$nouserpic) {
+                if (!$nouserpic && $subjectid != 0) {
+                    $subject = $DB->get_record('user', array('id' => $subjectid));
                     $questioninfo->userimage = $OUTPUT->user_picture($subject);
                 } else {
                    $questioninfo->userimage = '';
@@ -3919,14 +4401,30 @@ class appraisal_message {
      */
     public function send() {
         global $DB, $CFG;
+
         if ($this->triggered) {
             return false;
         }
-        $learners = $DB->get_records('appraisal_user_assignment', array('appraisalid' => $this->appraisalid));
+
+        $where = "appraisalid = ?";
+        $params = array($this->appraisalid);
+
+        // If this gets any more complex we might want to replace it with get_in_or_equal().
+        if ($this->type == 'appraisal_stage_completion') {
+            $where .= " AND (status = ? OR status = ?)";
+            $params[] = appraisal::STATUS_ACTIVE;
+            $params[] = appraisal::STATUS_COMPLETED;
+        } else {
+            $where .= " AND status = ?";
+            $params[] = appraisal::STATUS_ACTIVE;
+        }
+
+        $learners = $DB->get_records_select('appraisal_user_assignment', $where, $params);
         $sentaddress = array();
+
         foreach ($learners as $learner) {
             $params = array('appraisaluserassignmentid' => $learner->id);
-            $assignedroles = $DB->get_records('appraisal_role_assignment', $params, '', 'appraisalrole, userid');
+            $assignedroles = $DB->get_records('appraisal_role_assignment', $params, '', 'appraisalrole, id, userid');
             foreach ($this->roles as $role) {
                 if (isset($assignedroles[$role])) {
                     $rcptuserid = $assignedroles[$role]->userid;
@@ -3934,8 +4432,12 @@ class appraisal_message {
                     if ($this->type == self::EVENT_STAGE_DUE && $this->stageiscompleted != 0) {
                         // Get stage completion.
                         $stage = new appraisal_stage($this->stageid);
-                        $roleassignment = appraisal_role_assignment::get_role($this->appraisalid, $learner->userid, $rcptuserid, $role);
-                        $complete = $stage->is_completed($roleassignment);
+                        if ($role == appraisal::ROLE_LEARNER) {
+                            $approle = new appraisal_user_assignment($learner->id);
+                        } else {
+                            $approle = new appraisal_role_assignment($assignedroles[$role]->id);
+                        }
+                        $complete = $stage->is_completed($approle);
                         // Skip completed if set "only to incompleted" and contra versa.
                         if ($this->stageiscompleted == 1 && !$complete ||
                             $this->stageiscompleted == -1 && $complete) {
@@ -4124,140 +4626,6 @@ class appraisal_message {
     }
 }
 
-
-/**
- * Listener for appraisal specific events.
- */
-class appraisal_event_handler {
-    /**
-     * Activation message handler
-     * If message is not immediate - add sheduled event
-     * Also process stage_due as technically it's not an event but scheduled action
-     *
-     * @param \totara_appraisal\event\appraisal_activation $event
-     */
-    public static function appraisal_activation(\totara_appraisal\event\appraisal_activation $event) {
-        global $DB;
-
-        $time = $event->other['time'];
-        $appraisalid = $event->objectid;
-
-        $sql = "SELECT id FROM {appraisal_event} WHERE triggered = 0 AND event IN (?, ?) AND appraisalid = ?";
-        $params = array(appraisal_message::EVENT_APPRAISAL_ACTIVATION, appraisal_message::EVENT_STAGE_DUE, $appraisalid);
-        $events = $DB->get_records_sql($sql, $params);
-        foreach ($events as $id => $eventdata) {
-            $eventmessage = new appraisal_message($id);
-            self::process_event($eventmessage, $time);
-        }
-    }
-
-    /**
-     * User deleted message handler
-     *
-     * @param \totara_appraisal\event\appraisal_user_deleted $event
-     */
-    public static function appraisal_user_deleted(\core\event\user_deleted $event) {
-        global $DB;
-
-        $userid = $event->objectid;
-        $transaction = $DB->start_delegated_transaction();
-        $context = context_system::instance();
-        $fs = get_file_storage();
-        // Wipe data in appraisals assigned to this user.
-        $userassignments = $DB->get_records('appraisal_user_assignment', array('userid' => $userid));
-        foreach ($userassignments as $userassignment) {
-            $appraisalid = $userassignment->appraisalid;
-            $userassignmentid = $userassignment->id;
-            // Get all role assignments for this userassignment.
-            $roleassignments = $DB->get_records('appraisal_role_assignment', array('appraisaluserassignmentid' => $userassignmentid));
-            foreach ($roleassignments as $roleassignment) {
-                $roleassignmentid = $roleassignment->id;
-                $DB->delete_records('appraisal_scale_data', array('appraisalroleassignmentid' => $roleassignmentid));
-                $DB->delete_records('appraisal_quest_data_' . $appraisalid, array('appraisalroleassignmentid' => $roleassignmentid));
-                $DB->delete_records('appraisal_stage_data', array('appraisalroleassignmentid' => $roleassignmentid));
-                $fs->delete_area_files($context->id, 'totara_appraisal', 'snapshot_', $appraisalid, $roleassignmentid);
-            }
-            $DB->delete_records('appraisal_role_assignment', array('appraisaluserassignmentid' => $userassignmentid));
-        }
-        $DB->delete_records('appraisal_user_assignment', array('userid' => $userid));
-
-        // First mark the stages as complete for the users role assignments.
-        $sql = "SELECT ara.id, aua.activestageid
-                  FROM {appraisal_role_assignment} ara
-                  JOIN {appraisal_user_assignment} aua
-                    ON ara.appraisaluserassignmentid = aua.id
-                 WHERE ara.userid = ?";
-        $roleassignments = $DB->get_records_sql($sql, array($userid));
-
-        foreach ($roleassignments as $roleid => $stage) {
-            $stage = new appraisal_stage($stage->activestageid);
-            $roleassignment = new appraisal_role_assignment($roleid);
-
-            $stage->complete_for_role($roleassignment);
-        }
-
-        // Then flag their role assignments as deleted, but keep any existing data.
-        $sql = "UPDATE {appraisal_role_assignment} SET userid = 0 WHERE userid = ?";
-        $DB->execute($sql, array($userid));
-
-        $transaction->allow_commit();
-    }
-
-    /**
-     * Stage complete message handler
-     *
-     * @param \totara_appraisal\event\appraisal_stage_completion $event
-     */
-    public static function appraisal_stage_completion(\totara_appraisal\event\appraisal_stage_completion $event) {
-        global $DB;
-
-        $time = $event->other['time'];
-        $stageid = $event->other['stageid'];
-        $sql = "SELECT id FROM {appraisal_event} WHERE triggered = 0 AND event = ? AND appraisalstageid = ?";
-        $params = array(appraisal_message::EVENT_STAGE_COMPLETE, $stageid);
-        $events = $DB->get_records_sql($sql, $params);
-        foreach ($events as $id => $eventdata) {
-            self::process_event(new appraisal_message($id), $time);
-        }
-    }
-
-    /**
-     * Send or schedule messages according time and settings
-     *
-     * @param appraisal_message $event
-     * @param int $time
-     */
-    protected static function process_event(appraisal_message $event, $time) {
-        if ($event->is_immediate()) {
-            $event->send();
-        } else {
-            $event->schedule($event->get_schedule_from($time));
-            $event->save();
-        }
-    }
-
-
-    /**
-     * Get's all scheduled untriggered messages and send's them
-     *
-     * @param int $time current time
-     */
-    public static function send_scheduled($time) {
-        global $DB;
-        $sql = "SELECT ae.id
-                FROM {appraisal_event} ae JOIN {appraisal} a ON (ae.appraisalid = a.id)
-                WHERE a.status = ? AND timescheduled > 0 AND triggered = 0";
-        $events = $DB->get_records_sql($sql, array(appraisal::STATUS_ACTIVE));
-        foreach ($events as $id => $eventdata) {
-            $event = new appraisal_message($id);
-            if ($event->is_time($time)) {
-                $event->send();
-            }
-        }
-    }
-}
-
-
 /**
  * Serves the folder files.
  *
@@ -4642,7 +5010,13 @@ class appraisal_role_assignment {
                  AND ara.userid = ?
                  AND ara.appraisalrole = ?';
         $record = $DB->get_record_sql($sql, array($appraisalid, $subjectid, $userid, $role));
-        $roleassignment = new appraisal_role_assignment($record->id);
+
+        if ($record) {
+            $roleassignment = new appraisal_role_assignment($record->id);
+        } else {
+            $roleassignment = null;
+        }
+
         return $roleassignment;
     }
 
@@ -4729,6 +5103,12 @@ class appraisal_user_assignment {
     protected $user = null;
 
     /**
+     * User status
+     * @var int
+     */
+    protected $status = 0;
+
+    /**
      * Load role assignment
      * @param int $id
      */
@@ -4766,6 +5146,7 @@ class appraisal_user_assignment {
         $this->appraisalid = $userass->appraisalid;
         $this->activestageid = $userass->activestageid;
         $this->timecompleted = $userass->timecompleted;
+        $this->status = $userass->status;
         $this->preview = false;
         $this->user = $DB->get_record('user', array('id' => $this->userid));
     }
@@ -4797,6 +5178,27 @@ class appraisal_user_assignment {
         $userassignment = new appraisal_user_assignment($record->id);
         return $userassignment;
     }
+
+    /**
+     * Closes the appraisal for a user.
+     */
+    public function close() {
+        global $DB;
+
+        $this->status = appraisal::STATUS_CLOSED;
+
+        $todb = new stdClass();
+        $todb->id = $this->id;
+        $todb->status = $this->status;
+        $DB->update_record('appraisal_user_assignment', $todb);
+    }
+
+    /**
+     *
+     */
+    public function is_closed() {
+        return $this->status == appraisal::STATUS_CLOSED;
+    }
 }
 
 /**
diff --git a/totara/appraisal/lib/assign/ajax.php b/totara/appraisal/lib/assign/ajax.php
index 1769523..0e5e049 100644
--- a/totara/appraisal/lib/assign/ajax.php
+++ b/totara/appraisal/lib/assign/ajax.php
@@ -45,6 +45,7 @@ $assignclass = new $assignclassname($module, $appraisal);
 $users = $assignclass->get_current_users($ssearch, $idisplaystart, $idisplaylength);
 $igrandtotal = $assignclass->get_current_users_count();
 $idisplaytotal = $assignclass->get_current_users_count($ssearch);
+$emptyassignments = get_string('emptyassignments', 'totara_appraisal');
 
 // Since we only have one page we can save to an array.
 $userdata = array();
@@ -55,21 +56,25 @@ $users->close();
 
 // Get group info for the users on this page.
 $groupinfo = $assignclass->get_group_assignedvia_details(array_keys($userdata));
+
 $aadata = array();
 foreach ($userdata as $userid => $user) {
-    // Check for deleted users.
-    if (isset($groupinfo[$userid])) {
-        $url = new moodle_url('/user/view.php', array('id' => $user->id));
-        $link = html_writer::link($url, fullname($user));
-        $assignvia = array();
-        if (!empty($groupinfo)) {
-            foreach ($groupinfo[$userid] as $groupid => $groupstring) {
-                $assignvia[] = $groupstring;
-            }
+    $url = new moodle_url('/user/view.php', array('id' => $user->id));
+    $link = html_writer::link($url, fullname($user));
+
+    $assignvia = array();
+    if (!empty($groupinfo[$userid])) {
+        foreach ($groupinfo[$userid] as $groupid => $groupstring) {
+            $assignvia[] = $groupstring;
         }
+    }
+    if (empty($assignvia)) {
+        $assignviastring = $emptyassignments;
+    } else {
         $assignviastring = implode(', ', $assignvia);
-        $aadata[] = array($link, $assignviastring);
     }
+
+    $aadata[] = array($link, $assignviastring);
 }
 
 $output = array(
diff --git a/totara/appraisal/lib/assign/lib.php b/totara/appraisal/lib/assign/lib.php
index 240fa8b..5f2cee5 100644
--- a/totara/appraisal/lib/assign/lib.php
+++ b/totara/appraisal/lib/assign/lib.php
@@ -30,8 +30,17 @@ class totara_assign_appraisal extends totara_assign_core {
 
     protected static $module = 'appraisal';
 
-    public function store_user_assignments() {
-        parent::store_user_assignments();
+    public function store_user_assignments($newusers = null, $processor = null) {
+        // Define a processor function to format the data for appraisals.
+        $processor = function($record, $modulekey, $moduleinstanceid) {
+            $todb = new stdClass();
+            $todb->$modulekey = $moduleinstanceid;
+            $todb->userid = $record->id;
+            $todb->status = appraisal::STATUS_ACTIVE;
+            return $todb;
+        };
+
+        parent::store_user_assignments($newusers, $processor);
 
         $this->store_role_assignments();
     }
@@ -45,9 +54,6 @@ class totara_assign_appraisal extends totara_assign_core {
     private function store_role_assignments() {
         global $DB;
 
-        // Clear any existing records (so that we don't create duplicates).
-        $this->delete_role_assignments();
-
         // Get all roles required for this appraisal.
         $appraisal = new appraisal($this->moduleinstanceid);
         $roles = $appraisal->get_roles_involved();
@@ -57,43 +63,53 @@ class totara_assign_appraisal extends totara_assign_core {
                 case appraisal::ROLE_LEARNER:
                     $select = "SELECT ua.id, ua.userid, {$role}
                                  FROM {appraisal_user_assignment} ua
-                                WHERE ua.appraisalid = {$this->moduleinstanceid}";
+                               WHERE ua.appraisalid = {$this->moduleinstanceid}
+                                 AND NOT EXISTS (
+                                     SELECT id FROM {appraisal_role_assignment} ara WHERE ara.appraisaluserassignmentid = ua.id AND userid = ua.userid)";
+                    $params = array();
                     break;
                 case appraisal::ROLE_MANAGER:
-                    $select = "SELECT ua.id, pa.managerid, {$role}
+                    $select = "SELECT ua.id, CASE WHEN pa.managerid IS NULL THEN 0 ELSE pa.managerid END, ?
                                  FROM (SELECT * FROM {appraisal_user_assignment}
-                                        WHERE appraisalid = {$this->moduleinstanceid}) ua
-                                 JOIN (SELECT * FROM {pos_assignment} WHERE type = 1) pa
+                                        WHERE appraisalid = ?) ua
+                                 LEFT JOIN (SELECT * FROM {pos_assignment} WHERE type = ?) pa
                                    ON ua.userid = pa.userid
-                                WHERE pa.managerid IS NOT NULL";
+                                 WHERE NOT EXISTS (
+                                       SELECT id FROM {appraisal_role_assignment} ara WHERE ara.appraisaluserassignmentid = ua.id AND ara.appraisalrole = ?)";
+                    $params = array($role, $this->moduleinstanceid, POSITION_TYPE_PRIMARY, $role);
                     break;
                 case appraisal::ROLE_TEAM_LEAD:
-                    $select = "SELECT ua.id, pa2.managerid, {$role}
+                    $select = "SELECT ua.id, CASE WHEN pa2.managerid IS NULL THEN 0 ELSE pa2.managerid END, ?
                                  FROM (SELECT * FROM {appraisal_user_assignment}
-                                        WHERE appraisalid = {$this->moduleinstanceid}) ua
-                                 JOIN (SELECT * FROM {pos_assignment} WHERE type = 1) pa
+                                        WHERE appraisalid = ?) ua
+                                 LEFT JOIN (SELECT * FROM {pos_assignment} WHERE type = ?) pa
                                    ON ua.userid = pa.userid
-                                 JOIN (SELECT * FROM {pos_assignment} WHERE type = 1) pa2
+                                 LEFT JOIN (SELECT * FROM {pos_assignment} WHERE type = ?) pa2
                                    ON pa.managerid = pa2.userid
-                                WHERE pa2.managerid IS NOT NULL";
+                                 WHERE NOT EXISTS (
+                                       SELECT id FROM {appraisal_role_assignment} ara WHERE ara.appraisaluserassignmentid = ua.id AND ara.appraisalrole = ?)";
+                    $params = array($role, $this->moduleinstanceid, POSITION_TYPE_PRIMARY, POSITION_TYPE_PRIMARY, $role);
                     break;
                 case appraisal::ROLE_APPRAISER:
-                    $select = "SELECT ua.id, pa.appraiserid, {$role}
+                    $select = "SELECT ua.id, CASE WHEN pa.appraiserid IS NULL THEN 0 ELSE pa.appraiserid END, ?
                                  FROM (SELECT * FROM {appraisal_user_assignment}
-                                        WHERE appraisalid = {$this->moduleinstanceid}) ua
-                                 JOIN (SELECT * FROM {pos_assignment} WHERE type = 1) pa
+                                        WHERE appraisalid = ?) ua
+                                 LEFT JOIN (SELECT * FROM {pos_assignment} WHERE type = ?) pa
                                    ON ua.userid = pa.userid
-                                WHERE pa.appraiserid IS NOT NULL";
+                                 WHERE NOT EXISTS (
+                                        SELECT id FROM {appraisal_role_assignment} ara WHERE ara.appraisaluserassignmentid = ua.id AND ara.appraisalrole = ?)";
+                    $params = array($role, $this->moduleinstanceid, POSITION_TYPE_PRIMARY, $role);
                     break;
                 default:
                     // Error.
                     continue 2;
                     break;
             }
+
             $sql = "INSERT INTO {appraisal_role_assignment}
                         (appraisaluserassignmentid, userid, appraisalrole)
                         ({$select})";
-            $DB->execute($sql);
+            $DB->execute($sql, $params);
         }
     }
 
@@ -143,7 +159,7 @@ class totara_assign_appraisal extends totara_assign_core {
      * @return bool
      */
     public function is_locked() {
-        return !appraisal::is_draft($this->moduleinstanceid);;
+        return appraisal::is_closed($this->moduleinstanceid);;
     }
 
     /**
@@ -155,4 +171,25 @@ class totara_assign_appraisal extends totara_assign_core {
         return ($this->moduleinstance->status != appraisal::STATUS_DRAFT);
     }
 
+    /**
+     * Over ride in module code to add specific module related search queries.
+     *
+     * @param  $useralias       string  The alias of the user table.
+     * @param  $joinalias       string  The alias of the joined table.
+     * @param  $liveassignments boolean Flags which $joinalias table is being used.
+     * @return string  The additional where statement.
+     */
+    public function get_user_extra_search_where_sql($useralias, $joinalias, $liveassignments) {
+        $sql = "";
+        $params = array();
+
+        if ($liveassignments) {
+            // Extra search where clause on the user_assignments table.
+            $sql = "{$joinalias}.status <> ?";
+            $params = array(appraisal::STATUS_CLOSED);
+        }
+
+        return array($sql, $params);
+    }
+
 }
diff --git a/totara/appraisal/message.php b/totara/appraisal/message.php
index 2c28f68..3944f39 100644
--- a/totara/appraisal/message.php
+++ b/totara/appraisal/message.php
@@ -135,6 +135,11 @@ switch ($action) {
 }
 
 $output = $PAGE->get_renderer('totara_appraisal');
+
+$title = $PAGE->title . ': ' . $appraisal->name;
+$PAGE->set_title($title);
+$PAGE->set_heading($appraisal->name);
+$PAGE->navbar->add($appraisal->name);
 echo $output->header();
 echo $output->heading($appraisal->name);
 echo $output->appraisal_additional_actions($appraisal->status, $appraisal->id);
@@ -162,4 +167,4 @@ switch ($action) {
         }
         echo $output->appraisal_message_table($messages);
 }
-echo $output->footer();
\ No newline at end of file
+echo $output->footer();
diff --git a/totara/appraisal/missing.php b/totara/appraisal/missing.php
new file mode 100644
index 0000000..0f90f30
--- /dev/null
+++ b/totara/appraisal/missing.php
@@ -0,0 +1,72 @@
+<?php
+/*
+ * This file is part of Totara LMS
+ *
+ * Copyright (C) 2010 onwards Totara Learning Solutions LTD
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ *
+ * @author David Curry <david.curry@totaralms.com>
+ * @package totara
+ * @subpackage appraisal
+ */
+
+require_once(dirname(dirname(dirname(__FILE__))) . '/config.php');
+require_once($CFG->libdir.'/adminlib.php');
+require_once($CFG->dirroot . '/totara/appraisal/lib.php');
+
+// Check if Appraisals are enabled.
+appraisal::check_feature_enabled();
+
+// Get the appraisal id.
+$appraisalid = required_param('appraisalid', PARAM_INT);
+
+// Capability checks.
+$systemcontext = context_system::instance();
+$canassign = has_capability('totara/appraisal:assignappraisaltogroup', $systemcontext);
+$canviewusers = has_capability('totara/appraisal:viewassignedusers', $systemcontext);
+$appraisal = new appraisal($appraisalid);
+
+admin_externalpage_setup('manageappraisals');
+$PAGE->set_heading($appraisal->name);
+$PAGE->set_title(get_string('missingrolestitle', 'totara_appraisal', $appraisal->name));
+
+$output = $PAGE->get_renderer('totara_appraisal');
+echo $output->header();
+echo $output->heading($appraisal->name);
+
+if ($canviewusers || $canassign) {
+    $errors = $appraisal->validate_roles(true);
+    if (!empty($errors)) {
+        $explaination = get_string('missingroles', 'totara_appraisal');
+        $explaination .= get_string('missingrolesbelow', 'totara_appraisal');
+        echo html_writer::tag('p', $explaination);
+
+        $warndesc = array();
+        foreach ($errors as $warn) {
+            $warndesc[] = html_writer::tag('li', $warn);
+        }
+        echo html_writer::tag('ul', implode('', $warndesc), array('class' => 'appraisalerrorlist'));
+
+    } else {
+        // Looks like all the roles are filled.
+        echo html_writer::tag('p', get_string('missingrolesnone', 'totara_appraisal'));
+
+    }
+} else {
+    // You should not be viewing this page.
+    print_error('error:pagepermissions', 'totara_appraisal');
+}
+
+echo $output->footer();
